/*! @file demo.cpp
	
	@brief ODEgV~[V

	@author Makoto Fujisawa
	@date 2008-08, 2010-02
*/


//#pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")

//-----------------------------------------------------------------------------
// CN[ht@C
//-----------------------------------------------------------------------------
#include "rx_common.h"
#include "rx_trackball.h"


//-----------------------------------------------------------------------------
// MARK:`/萔
//-----------------------------------------------------------------------------
const GLfloat RX_LIGHT0_POS[4] = {  2.0f, 4.0f, 1.0f, 0.0f };
const GLfloat RX_LIGHT1_POS[4] = { -1.0f, -10.0f, -1.0f, 0.0f };

const GLfloat RX_LIGHT_DIFF[4] = { 0.9f, 0.9f, 0.9f, 1.0f };
const GLfloat RX_LIGHT_SPEC[4] = { 0.3f, 0.3f, 0.3f, 1.0f };
const GLfloat RX_LIGHT_AMBI[4] = { 0.1f, 0.1f, 0.1f, 1.0f };

const GLfloat RX_FOV = 45.0f;


//-----------------------------------------------------------------------------
// MARK:O[oϐ
//-----------------------------------------------------------------------------
//! EBhETCY
int g_iWinW = 720;
int g_iWinH = 720;
int g_iMouseButton = -1;	//!< }EX{^̏
bool g_bIdle;				//!< Aj[VtO

// ODE֘Aϐ
bool g_bWorldCreated = false;	//!< ODE[h쐬tO
double g_fDt = 0.005;			//!< ^CXebv

dWorldID g_dWorld;				//!< ODE[h
dSpaceID g_dSpace;				//!< ODE
dJointGroupID g_dContactGroupID;//!< WCgO[v

dGeomID g_dGround;				//!< 
vector<dBodyID> g_vRObjs;		//!< 
vector<dJointID> g_vJoints;		//!< WCg

dBodyID g_dKCubeID = 0;			//!< KinematicŝID

double g_fCubeLen = 0.1;		//!< ̂̑傫
bool g_bCrtContact = false; 



//-----------------------------------------------------------------------------
// MARK:ODE֘A
//-----------------------------------------------------------------------------
//! Փ˃R[obN֐p̃f[^
struct NearCallData
{
	dWorldID* world;
	dJointGroupID* contact;
};


/*!
 * ODȄՓˏ
 *  2̂̋̕߂ƂODEĂ΂R[obN֐
 * @param[in] data 
 * @param[in] o1 1̃WIgID
 * @param[in] o2 2̃WIgID
 */
static void ODENearCallback(void *data, dGeomID o1, dGeomID o2)
{
	// Փ˔肷镨̂̃{fBID擾
	dBodyID b1 = dGeomGetBody(o1);
	dBodyID b2 = dGeomGetBody(o2);
	if(b1 && b2 && dAreConnected(b1, b2)){
		return;
	}
	
	// ڐG
	dContact contact[RX_MAX_CONTACTS];
	int n = dCollide(o1, o2, RX_MAX_CONTACTS, &contact[0].geom, sizeof(dContact));

	if(n > 0){	// 1_ȏł̐ڐGꍇ
		for(int i = 0; i < n; ++i){
			// ڐGƂɃp[^ݒ
			contact[i].surface.mode = dContactBounce | dContactSlip1 | dContactSlip2/* | dContactSoftERP | dContactSoftCFM | dContactApprox1*/;

			contact[i].surface.mu = 1.0;		// N[CW
			contact[i].surface.bounce = 0.1;	// e͐[0,1]
			contact[i].surface.bounce_vel = 0.001;
			contact[i].surface.slip1 = 0.0;
			contact[i].surface.slip2 = 0.0;
//			contact[i].surface.soft_erp = 0.1;
//			contact[i].surface.soft_cfm = 0.01;

			dJointID c = dJointCreateContact(*(((NearCallData*)data)->world), *(((NearCallData*)data)->contact), contact+i);
			dJointAttach(c, dGeomGetBody(o1), dGeomGetBody(o2));
		}

		//cout << "contact!" << endl;
	}
}

/*!
 * ODĚvZXebvi߂
 */
void StepODE(void)
{
	NearCallData data;
	data.world = &g_dWorld;
	data.contact = &g_dContactGroupID;
	dSpaceCollide(g_dSpace, &data, &ODENearCallback);
	dWorldQuickStep(g_dWorld, g_fDt);
	dJointGroupEmpty(g_dContactGroupID);

	// ̂](pxݒ)
	if(g_dKCubeID){
		dBodySetAngularVel(g_dKCubeID, 0.0, 10.0, 10.0);
	}

	// ̂𕽍sړ(xݒ)
	//dBodySetLinearVel(g_dKCubeID, 0.1, 0.0, 0.0);
}

/*!
 * ODEԂɗ̂zu
 * @param[in] pos ʒu
 * @param[in] len Ӓ
 */
void SetODECube(Vec3 pos, double len)
{
	double d = 10*len;
	if(!g_vRObjs.empty()){
		// ŌɒǉIuWFNgƂ̋
		d = norm(pos-ODE_GetPosition(g_vRObjs.back()));
	}

	// ǉʒuɕʂ̃IuWFNgȂΒǉ
	if(d > len){
		// ̂̏dZo
		dMass mass;
		dMassSetBox(&mass, 1.0, (dReal)len, (dReal)len, (dReal)len);
		dMassAdjust(&mass, 1.0);

		// `̍쐬
		dGeomID geom = dCreateBox(g_dSpace, (dReal)len, (dReal)len, (dReal)len);

		// {fB̍쐬
		dBodyID body = dBodyCreate(g_dWorld);
		dBodySetMass(body, &mass);
		dGeomSetBody(geom, body);

		// ʒuݒ
		dBodySetPosition(body, pos[0], pos[1], pos[2]);

		g_vRObjs.push_back(body);
	}
}

/*!
 * ODEԂɗ̂zu
 * @param[in] pos ʒu
 * @param[in] len Ӓ
 */
void ShootODESphere(Vec3 pos, Vec3 dir, double rad, double vel)
{
	// ̂̏dZo

	dMass mass;
	dMassSetSphere(&mass, 1.0, (dReal)rad);
	dMassAdjust(&mass, 1.0);

	// `̍쐬
	dGeomID geom = dCreateSphere(g_dSpace, (dReal)rad);

	// {fB̍쐬
	dBodyID body = dBodyCreate(g_dWorld);
	dBodySetMass(body, &mass);
	dGeomSetBody(geom, body);

	// ʒuݒ
	dBodySetPosition(body, pos[0], pos[1], pos[2]);

	// xݒ
	dBodySetLinearVel(body, vel*dir[0], vel*dir[1], vel*dir[2]);

	g_vRObjs.push_back(body);
}

/*!
 * ODEԂ̏
 */
void InitODE(void)
{
	dInitODE2(0);

	// ODEԂ̔j(ɑ݂Ă)
	if(g_bWorldCreated){
		dJointGroupDestroy(g_dContactGroupID);
		dSpaceDestroy(g_dSpace);
		dWorldDestroy(g_dWorld);
	}

	// ODEԂ̐
	g_dWorld = dWorldCreate();
	g_dSpace = dHashSpaceCreate(0);
	g_dContactGroupID = dJointGroupCreate(0);

	// ODEԃp[^̐ݒ
	dWorldSetGravity(g_dWorld, 0, -9.8, 0);			// d
	dWorldSetCFM(g_dWorld, 1e-5);					// O[oCFM(constraint force mixing) : Typical Value [10^-9, 1.0]
	dWorldSetContactMaxCorrectingVel(g_dWorld, 0.1);
	dWorldSetERP(g_dWorld, 0.8);					// O[oERP

	dWorldSetLinearDamping(g_dWorld, 0.00001);		// CR(sړx)
	dWorldSetAngularDamping(g_dWorld, 0.005);		// CR(px)
	dWorldSetMaxAngularSpeed(g_dWorld, 200);		// őpx
	dWorldSetContactSurfaceLayer(g_dWorld, 0.05);	// ڐGw̌(̑wɂ镨̂͐ڐGĂƂ)
	dWorldSetAutoDisableFlag(g_dWorld, 1);			// ΂炭ĂȂbodydisable

	g_bWorldCreated = true;

	// 
	g_dGround = dCreatePlane(g_dSpace, 0, 1, 0, 0);

	// 
	g_bCrtContact = false;
	SetODECube(Vec3(0.0, 0.8, 0.0), g_fCubeLen);
	//SetODECube(Vec3(0.0, 0.2, 0.0), g_fCubeLen);

	// ̂Kinematics{fBɂ
	//g_dKCubeID = g_vRObjs.back();
	//dBodySetKinematic(g_dKCubeID);
	//dBodySetDynamic(g_dKCubeID);
}

void CleanODE(void)
{
	if(g_bWorldCreated){
		for(int i = 0; i < (int)g_vRObjs.size(); ++i){
			dBodyDestroy(g_vRObjs[i]);
		}
		dGeomDestroy(g_dGround);

		dJointGroupDestroy(g_dContactGroupID);
		dSpaceDestroy(g_dSpace);
		dWorldDestroy(g_dWorld);

		dCloseODE();
	}
}


//-----------------------------------------------------------------------------
// MARK:`֐
//-----------------------------------------------------------------------------
/*!
 * xyz`(x:,y:,z:)
 * @param[in] len ̒
 */
inline int DrawAxis(double len, double line_width = 5.0)
{
	glLineWidth(line_width);

	// x
	glColor3f(1.0, 0.0, 0.0);
	glBegin(GL_LINES);
	glVertex3d(0.0, 0.0, 0.0);
	glVertex3d(len, 0.0, 0.0);
	glEnd();

	// y
	glColor3f(0.0, 1.0, 0.0);
	glBegin(GL_LINES);
	glVertex3d(0.0, 0.0, 0.0);
	glVertex3d(0.0, len, 0.0);
	glEnd();

	// z
	glColor3f(0.0, 0.0, 1.0);
	glBegin(GL_LINES);
	glVertex3d(0.0, 0.0, 0.0);
	glVertex3d(0.0, 0.0, len);
	glEnd();

	return 1;
}


/*!
 * V[̕`
 */
void DrawScene(void)
{
	// ގ
	static const GLfloat difr[] = { 1.0, 0.4, 0.4, 1.0 };	// gUF : 
	static const GLfloat difg[] = { 0.4, 0.6, 0.4, 1.0 };	// gUF : 
	static const GLfloat difb[] = { 0.4, 0.4, 1.0, 1.0 };	// gUF : 
	static const GLfloat spec[] = { 0.3, 0.3, 0.3, 1.0 };	// ʔːF
	static const GLfloat ambi[] = { 0.1, 0.1, 0.1, 1.0 };	// 

	glEnable(GL_LIGHTING);
	glEnable(GL_DEPTH_TEST);
	glCullFace(GL_BACK);
	glEnable(GL_CULL_FACE);
	glDisable(GL_COLOR_MATERIAL);

	// ގݒ
	glMaterialfv(GL_FRONT, GL_SPECULAR, spec);
	glMaterialfv(GL_FRONT, GL_AMBIENT,  ambi);
	glMaterialf(GL_FRONT, GL_SHININESS, 50.0);

    glPolygonMode(GL_FRONT, GL_FILL);
	glColor3f(0.0, 0.0, 1.0);

	// ̂`
	for(int i = 0; i < (int)g_vRObjs.size(); ++i){
		dBodyID body = g_vRObjs[i];
		if(dBodyIsKinematic(body)){	// Kinematic{fB̏ꍇ͐Ԃŕ`
			glMaterialfv(GL_FRONT, GL_DIFFUSE, difr);
		}
		else{	// ̑̃{fB͐ŕ`
			glMaterialfv(GL_FRONT, GL_DIFFUSE, difb);
		}

		glPushMatrix();

		Vec3 pos;
		GLfloat m[16];

		pos = ODE_GetPosition(body);
		ODE_GetRotationMatrix(body, m);
		
		glTranslatef(pos[0], pos[1], pos[2]);
		glMultMatrixf(m);

		// `̎擾
		dGeomID geom = dBodyGetFirstGeom(body);

		// `^Cv̎擾
		int type = dGeomGetClass(geom);

		// `󂲂Ƃ̕`
		if(type == dBoxClass){
			dReal sl[4];
			dGeomBoxGetLengths(geom, sl);

			glScalef(sl[0], sl[1], sl[2]);
			glutSolidCube(1.0);
		}
		else if(type == dSphereClass){
			dReal rad = dGeomSphereGetRadius(geom);

			glutSolidSphere(rad, 32, 16);
		}
		else if(type == dCapsuleClass){
			dReal rad, len;
			dGeomCapsuleGetParams(geom, &rad, &len);

			DrawCapsule(rad, len, 20);
		}
		else if(type == dCylinderClass){
			dReal rad, len;
			dGeomCylinderGetParams(geom, &rad, &len);

			DrawCylinder(rad, len, 20);
		}
		glPopMatrix();
	}

	// `
	glMaterialfv(GL_FRONT, GL_DIFFUSE,  difg);
	glPushMatrix();
	glColor3f(0.0, 1.0, 0.0);
	glNormal3f(0.0, 1.0, 0.0);
	glBegin(GL_POLYGON);
	glVertex3f(-10.0, 0.0, -10.0);
	glVertex3f(-10.0, 0.0,  10.0);
	glVertex3f( 10.0, 0.0,  10.0);
	glVertex3f( 10.0, 0.0, -10.0);
	glEnd();
	glPopMatrix();

	// 
	//glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
	//glEnable(GL_COLOR_MATERIAL);
	//glDisable(GL_LIGHTING);
	//DrawAxis(1.0);

}



/*!
 * `֐
 */
void Display(void)
{
	// MARK:Display
	glClearColor(0.8, 0.8, 0.9, 1.0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	// _ʒuƕ
	Vec3 eye_pos, eye_dir;
	eye_pos = GetEyePos();
	eye_dir = GetEyeDir();

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glPushMatrix();

	// _
	gluLookAt(eye_pos[0], eye_pos[1], eye_pos[2],  
			  eye_pos[0]+eye_dir[0], eye_pos[1]+eye_dir[1], eye_pos[2]+eye_dir[2],  
			  0.0, 1.0, 0.0);

	// ʒu
	glLightfv(GL_LIGHT0, GL_POSITION, RX_LIGHT0_POS);

	DrawScene();

	glPopMatrix();

	glutSwapBuffers();
}


/*!
 * TCYCxg֐
 * @param[in] w,h LoXTCY
 */
void Resize(int w, int h)
{
	glViewport(0, 0, w, h);
	SetTrackballRegion(w, h);

	g_iWinW = w;
	g_iWinH = h;

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(RX_FOV, (float)w/(float)h, 0.01f, 20.0f);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

/*!
 * }EXCxg֐
 * @param[in] button }EX{^(GLUT_LEFT_BUTTON,GLUT_MIDDLE_BUTTON,GLUT_RIGHT_BUTTON)
 * @param[in] state }EX{^̏(GLUT_UP, GLUT_DOWN)
 * @param[in] x,y }EXW(XN[Wn)
 */
void Mouse(int button, int state, int x, int y)
{
	if(state == GLUT_DOWN){
		StartTrackball(x, y);
	}
	else if(state == GLUT_UP){
		StopTrackball(x, y);
	}

	g_iMouseButton = button;
}

/*!
 * [VCxg֐(}EX{^܂܃hbO)
 * @param[in] x,y }EXW(XN[Wn)
 */
void Motion(int x, int y)
{
	if(g_iMouseButton == GLUT_LEFT_BUTTON){
		RotateM(x, y);
	}
	else if(g_iMouseButton == GLUT_MIDDLE_BUTTON){
		TranslateM(x, y);
	}
	else if(g_iMouseButton == GLUT_RIGHT_BUTTON){
		ScalingM(x, y);
	}
	glutPostRedisplay();
}

/*!
 * AChCxg֐(CPUɂȂƂɎs)
 */
void Idle(void)
{
	// MARK:Idle
	StepODE();
	glutPostRedisplay();
}

/*!
 * ^C}[Cxg֐(鎞ԊԊuŎs)
 */
void Timer(int value)
{
	// MARK:Timer
	StepODE();
	glutPostRedisplay();
	glutTimerFunc(g_fDt*1000 , Timer , 0);
}


/*!
 * w肵͈͂̎̐
 */
inline double Random(const double &_max, const double &_min)
{
	return (_max-_min)*(rand()/(double)RAND_MAX)+_min;
}

/*!
 * L[{[hCxg֐
 * @param[in] key L[̎
 * @param[in] x,y L[ꂽƂ̃}EXW(XN[Wn)
 */
void Keyboard(unsigned char key, int x, int y)
{
	// MARK:Keyboard
	switch(key){
	case '\033':  // '\033'  ESC  ASCII R[h
		exit(0);

	case 's':
		g_bIdle = !g_bIdle;
		if(g_bIdle){
			glutIdleFunc(Idle);
		}
		else{
			glutIdleFunc(0);
		}
		break;

	case 'c':
		{
			double x = Random(0.1, -0.1);
			double y = Random(0.1, -0.1);
			double dl = Random(0.5, 1.5);
			SetODECube(Vec3(x, 0.8, y), g_fCubeLen*dl);
		}
		break;

	case 'b':
		ShootODESphere(GetEyePos(), GetEyeDir(), 0.4*g_fCubeLen, 20.0);
		break;

	case 'x':
		break;

	default:
		break;
	}
}

/*!
 * L[{[hCxg֐
 * @param[in] key L[̎
 * @param[in] x,y L[ꂽƂ̃}EXW(XN[Wn)
 */
void SpecialKey(int key, int x, int y)
{
	if(key == GLUT_KEY_LEFT){
	}
	else if(key == GLUT_KEY_RIGHT){
	}
}


/*!
 * OpenGL̏
 */
void InitGL(void)
{
	// OpenGL̃o[W`FbN
	printf("OpenGL Ver. %s\n", glGetString(GL_VERSION));

	// wiF
	glClearColor(0.8, 0.8, 0.9, 1.0);
    glClearDepth(1.0);

    glEnable(GL_DEPTH_TEST);
    glDepthFunc(GL_LEQUAL);
	glEnable(GL_CULL_FACE);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);

	// ̏ݒ
	glEnable(GL_LIGHTING);
	glLightfv(GL_LIGHT0, GL_DIFFUSE,  RX_LIGHT_DIFF);
	glLightfv(GL_LIGHT0, GL_SPECULAR, RX_LIGHT_SPEC);
	glLightfv(GL_LIGHT0, GL_AMBIENT,  RX_LIGHT_AMBI);

	glShadeModel(GL_SMOOTH);

	glEnable(GL_AUTO_NORMAL);
	glEnable(GL_NORMALIZE);

	// _̏
	InitTrackball();
	SetEyePos(Vec3(0.0, 0.5, 2.0));

	InitODE();
}


/*!
 * I֐
 */
void Clean(void)
{
	CleanODE();
}


/*!
 * C[`
 * @param[in] argc R}hC̐
 * @param[in] argv R}hC
 */
int main(int argc, char *argv[])
{
	// MARK:main
	glutInitWindowPosition(100, 100);
	glutInitWindowSize(g_iWinW, g_iWinH);
	glutInit(&argc, argv);

	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	glutCreateWindow(argv[0]);

	glutDisplayFunc(Display);
	glutReshapeFunc(Resize);
	glutMouseFunc(Mouse);
	glutMotionFunc(Motion);
	glutKeyboardFunc(Keyboard);
	glutSpecialFunc(SpecialKey);
	//glutIdleFunc(Idle);
	glutTimerFunc(g_fDt*1000, Timer, 0);
	g_bIdle = true;

	InitGL();

	glutMainLoop();

	Clean();

	return 0;
}

