/*! @file trackball.cpp
	
	@brief ȈՃgbN{[
			- ODEdQuaterniongp
 
	@author Makoto Fujisawa
	@date 2008
*/


//-----------------------------------------------------------------------------
// CN[ht@C
//-----------------------------------------------------------------------------
#include "rx_trackball.h"


#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif


//-----------------------------------------------------------------------------
// O[oϐ
//-----------------------------------------------------------------------------
dQuaternion g_dQRotation0;	//!< NH[^jI
dQuaternion g_dQRotation1;	//!< ]̃NH[^jI
Vec3 g_vRotCenter(0.0);		//!< ]S
Vec3 g_vCamView(0.0, 0.0, -1.0);	//!< 

//! hbOJnʒu
int g_iLastx, g_iLasty;

//! }EX̐ΈʒuEBhEł̑ΈʒůZW
double g_fScale[2] = {1.0, 1.0};

//! ϊs
double g_fM[16];	//!< ]s
double g_fT[16];	//!< sړs
double g_fMt[16];

//! hbOtO
int g_bDrag = 0;



//-----------------------------------------------------------------------------
// gbN{[֐
//-----------------------------------------------------------------------------
/*!
 * gbN{[̏
 * @@vȌ̂ƂŎs
 */
void InitTrackball(void)
{
	// hbOł͂Ȃ
	g_bDrag = 0;

	// PʃNH[^[jI
	dQSetIdentity(g_dQRotation0);
	dQSetIdentity(g_dQRotation1);

	// ]s̏
	ODE_QToM16(g_fM, g_dQRotation0);
	//dQtoR(g_dQRotation0, g_dMRotation);
	//ODE_Matrix3ToM16(g_fM, g_dMRotation);

	MakeIdentity(g_fT);
	MakeIdentity(g_fMt);
}

/*!
 * gbN{[̈
 *  - Reshape R[obN (resize) ̒Ŏs
 */
void SetTrackballRegion(int w, int h)
{
	// }EX|C^ʒũEBhȆΓIʒuւ̊Zp
	g_fScale[0] = 1.0/(double)w;
	g_fScale[1] = 1.0/(double)h;
}

/*!
 * hbOJn - }EX{^ƂɎs
 * @param[in] x,y }EXW(sNZW)
 */
void StartTrackball(int x, int y)
{
	// hbOJn
	g_bDrag = 1;

	// hbOJn_L^
	g_iLastx = x;
	g_iLasty = y;
}

/*!
 * }EXhbOɂ]
 * @param[in] x,y }EXW(sNZW)
 */
void RotateM(int x, int y)
{
	if(g_bDrag){
		double dx, dy, a;

		// }EX|C^̈ʒũhbOJnʒu̕ψ
		dx = (x-g_iLastx)*g_fScale[0];
		dy = (y-g_iLasty)*g_fScale[1];

		// }EX|C^̈ʒũhbOJnʒű
		a = sqrt(dx*dx+dy*dy);

		if(a != 0.0){
			double ar = 2.0*M_PI*a*0.5;

			dQuaternion dqt;
			dQFromAxisAndAngle(dqt, dy, dx, 0.0, ar);
			dQMultiply0(g_dQRotation1, dqt, g_dQRotation0);

			ODE_QToM16(g_fM, g_dQRotation1);

			g_dQRotation0[0] = g_dQRotation1[0];
			g_dQRotation0[1] = g_dQRotation1[1];
			g_dQRotation0[2] = g_dQRotation1[2];
			g_dQRotation0[3] = g_dQRotation1[3];

			g_vCamView = Unit(MultiQV(g_dQRotation1, Vec3(0.0, 0.0, -1.0)));
		}

		g_iLastx = x;
		g_iLasty = y;
	}
}

/*!
 * }EXhbOɂ镽sړ(ɐȕʓł̈ړ)
 * @param[in] x,y }EXW(sNZW)
 */
void TranslateM(int x, int y)
{
	if(g_bDrag){
		double dx, dy;

		// }EX|C^̈ʒũhbOJnʒu̕ψ
		dx = (x-g_iLastx)*g_fScale[0];
		dy = (y-g_iLasty)*g_fScale[1];

		g_vRotCenter += g_vCamView*Vec3(dx, dy, 0);

		//SetTranslate(g_fT, -g_vRotCenter);

		g_iLastx = x;
		g_iLasty = y;
	}
}

/*!
 * }EXhbOɂXP[O(ړ)
 * @param[in] x,y }EXW(sNZW)
 */
void ScalingM(int x, int y)
{
	if(g_bDrag){
		double dx, dy;

		// }EX|C^̈ʒũhbOJnʒu̕ψ
		dx = (x-g_iLastx)*g_fScale[0];
		dy = (y-g_iLasty)*g_fScale[1];

		g_vRotCenter += g_vCamView*dy;
		
		//SetTranslate(g_fT, -g_vRotCenter);

		g_iLastx = x;
		g_iLasty = y;
	}
}

/*!
 * ~ - }EX{^𗣂ƂɎs
 * @param[in] x,y }EXW(sNZW)
 */
void StopTrackball(int x, int y)
{
	// hbOI_ɂ]߂
	//RotateM(x, y);

	// ]̕ۑ
	g_dQRotation0[0] = g_dQRotation1[0];
	g_dQRotation0[1] = g_dQRotation1[1];
	g_dQRotation0[2] = g_dQRotation1[2];
	g_dQRotation0[3] = g_dQRotation1[3];

	// hbOI
	g_bDrag = 0;
}

/*
 * ]̕ϊs߂
 *  - ߂l glMultMatrixd() ȂǂŎgpăIuWFNg]
 */
double *GetTrackballRotation(void)
{
	//MultiMatrix4x4(g_fMt, g_fT, g_fM);
	return g_fM;
}


Vec3 GetEyePos(void)
{
	return g_vRotCenter;
}

void SetEyePos(const Vec3 &pos)
{
	g_vRotCenter = pos;
	//SetTranslate(g_fT, -g_vRotCenter);
}

Vec3 GetEyeDir(void)
{
	return g_vCamView;
}